package fr.mael.jiwigo.service;

import java.io.IOException;
import java.util.List;

import fr.mael.jiwigo.om.Image;
import fr.mael.jiwigo.om.Tag;
import fr.mael.jiwigo.transverse.exception.ProxyAuthenticationException;

public interface TagService {

    /**
     * Lists all tags
     * @return le list of tags
     * @throws IOException
     * @throws ProxyAuthenticationException
     */
    public List<Tag> list() throws IOException, ProxyAuthenticationException;

    /**
     * Creates a tag
     * @param nom name of the tag
     * @return true if the tag is created
     * @throws IOException
     * @throws ProxyAuthenticationException
     */
    public boolean create(String nom) throws IOException, ProxyAuthenticationException;

    /**
     * Returns all the tag for an image
     * @param image the image to check
     * @return the list of tags
     * @throws IOException
     * @throws ProxyAuthenticationException
     */
    public List<Tag> tagsForImage(Image image) throws IOException, ProxyAuthenticationException;
}
